// CompiladorView.cpp : implementation of the CCompiladorView class
//

#include "stdafx.h"
#include "Compilador.h"

#include "CompiladorDoc.h"
#include "CntrItem.h"
#include "CompiladorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCompiladorView

IMPLEMENT_DYNCREATE(CCompiladorView, CRichEditView)

BEGIN_MESSAGE_MAP(CCompiladorView, CRichEditView)
	//{{AFX_MSG_MAP(CCompiladorView)
	ON_WM_DESTROY()
	ON_UPDATE_COMMAND_UI(ID_COMPILE, OnUpdateCompile)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CRichEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CRichEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCompiladorView construction/destruction

CCompiladorView::CCompiladorView()
{
}

CCompiladorView::~CCompiladorView()
{
}

BOOL CCompiladorView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CRichEditView::PreCreateWindow(cs);
}

void CCompiladorView::OnInitialUpdate()
{
	CRichEditView::OnInitialUpdate();

	SetMargins(CRect(720, 720, 720, 720));
}

/////////////////////////////////////////////////////////////////////////////
// CCompiladorView printing

BOOL CCompiladorView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}


void CCompiladorView::OnDestroy()
{
   CRichEditView::OnDestroy();
   COleClientItem* pActiveItem = GetDocument()->GetInPlaceActiveItem(this);
   if (pActiveItem != NULL && pActiveItem->GetActiveView() == this)
   {
      pActiveItem->Deactivate();
      ASSERT(GetDocument()->GetInPlaceActiveItem(this) == NULL);
   }
}


/////////////////////////////////////////////////////////////////////////////
// CCompiladorView diagnostics

#ifdef _DEBUG
void CCompiladorView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void CCompiladorView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

CCompiladorDoc* CCompiladorView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCompiladorDoc)));
	return (CCompiladorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCompiladorView message handlers

void CCompiladorView::OnUpdateCompile(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((GetTextLength() == 0) ? FALSE:TRUE);
}
