// OutputView.cpp : implementation file
//

#include "stdafx.h"
#include "Compilador.h"
#include "CompiladorDoc.h"
#include "OutputView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COutputView

IMPLEMENT_DYNCREATE(COutputView, CRichEditView)

COutputView::COutputView()
{
}

COutputView::~COutputView()
{
}

#define WM_PROGRESS WM_USER + 5

BEGIN_MESSAGE_MAP(COutputView, CRichEditView)
	//{{AFX_MSG_MAP(COutputView)
	ON_WM_RBUTTONDOWN()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_PROGRESS, OnProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutputView diagnostics

#ifdef _DEBUG
void COutputView::AssertValid() const
{
	CRichEditView::AssertValid();
}

void COutputView::Dump(CDumpContext& dc) const
{
	CRichEditView::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COutputView message handlers

void COutputView::OnInitialUpdate() 
{
	CRichEditView::OnInitialUpdate();
	
	GetRichEditCtrl().SetBackgroundColor(FALSE, RGB(255, 251, 240));
	GetRichEditCtrl().SetReadOnly();
	GetRichEditCtrl().HideSelection(TRUE, FALSE);
}

LRESULT COutputView::OnProgress(WPARAM wParam, LPARAM lParam)
{
	m_strOut = "Hola";

	Invalidate();

	return 0L;
}

void COutputView::OnDraw(CDC* pDC) 
{
	pDC->TextOut(10, 10, m_strOut);
}

void COutputView::OnCompile(CString& strOutputPath, CTimeSpan& timeSpan, int codeErr)
{
	COMPCODE error = (COMPCODE) codeErr;
	CRichEditCtrl& editCtrl = GetRichEditCtrl();

	if (error == COMP_ERROR || error == PARSER_NOEJEC) {
		editCtrl.SetWindowText("Error al compilar");
		return;
	}
	
    CFile file;
	if (file.Open(strOutputPath, CFile::modeRead) == 0) {
		editCtrl.SetWindowText("Error al leer el archivo de salida (.out)");
		return;
	}
	
	CArchive ar(&file,CArchive::load);
	CString str, strOut;

	while (ar.ReadString(str))
		strOut += str + "\n";

	if (error == PARSER_CONERROR || error == TASM_NOEJEC) {
		editCtrl.SetWindowText(strOut);
		editCtrl.LineScroll(editCtrl.GetLineCount() - 8);
		return;
	}
	
	char szLogText[512];
	UINT c;

	CFile logFile;
	
	if (logFile.Open("log.txt", CFile::modeRead) == 0)
		editCtrl.SetWindowText("\nError al leer el archivo log.txt\n)");
	else if ((c = logFile.Read(szLogText, 512)) > 0) 
	{
		if (c == 512)
			szLogText[511] = '\0';
		else
			szLogText[c] = '\0';

		CString aux;
		aux.Format("\n\n%s", szLogText);
		
		strOut += aux;
	}

	strOut += timeSpan.Format("\nTiempo utilizado: %M:%S");

	editCtrl.SetWindowText(strOut);
	editCtrl.LineScroll(editCtrl.GetLineCount() - 8);
}


void COutputView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CDocument* pDoc = GetDocument();

	MessageBox("Listo para la prueba");

	ASSERT_KINDOF(CCompiladorDoc, pDoc);

	CRichEditView::OnRButtonDown(nFlags, point);
}
