#include <yacc.h>

#line 1 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

	/* Analizador gramatical, TP2 y TP3
	 * Integrantes: Yanina Manassa, Analia Jahnig, Diego Macrini
	 */           
	 #include <windows.h>
	 #include <stdio.h>     
	 #include "SharedTypes.h"
	 
	 extern "C" FILE *yyout;
	 extern CSList<SYMBOL> symTable;
	 extern CSList<char*>  stringList;
	 extern int g_nLine;
	 extern int g_nErrors;
	 extern bool g_bDeclaracion;
	 
	 double g_fNroVersion = 3.00;
	 
	 CSList<CUARTETO> cuartetos;	// Lista de cuartetos
	 CSList<LABEL>	  labels;
	 CStack<PSYMBOL>  freeVarTemps;	// Pila de variables temporables libres
	 
	 #define ConcatenarCodigo(A, B) A.GetList().AddTail(B.GetList())

	 void AddCuartetoOpBinario(int label, SA& arg1, SA& arg2, SA& res);
	 void AddCuartetoAsign(int label, PSYMBOL arg1, SA& arg2, SA& res);
	 void AddCuartetoMenosUnario(SA& arg1, SA& res);
	 void AddCuartetoWhile(SA& condicion, SA& sentencia, SA& res);
	 void AddCuartetoIf(SA& condicion, SA& sentencia, SA& res);
	 void AddCuartetoIfElse(SA& condicion, SA& sentencia, SA& sentElse, SA& res);	 
	 void AddCuartetoRead(int label, PSYMBOL arg1, SA& res);
	 void AddCuartetoWrite(int label, PSTRING arg1, SA& res);
	 void AddCuartetoWrite(int label, SA& arg1, SA& res);
	 void AddCuartetoNewLine(int label, SA& res);
	 void AddCuartetoComp(int label, SA& arg1, SA& arg2, SA& res);
	 void AddCuartetoOR(int label, SA& arg1, SA& arg2, SA& res);
	 void AddCuartetoAND(int label, SA& arg1, SA& arg2, SA& res);
	 
	 extern void GenerarCodigo(char*);
	 
	 void ErrorMessage(char* szMsg);

#line 46 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
#include "gramatica.h"
/* repeated because of possible precompiled header */
#include <yacc.h>

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#ifndef YYSTACK_SIZE
#define YYSTACK_SIZE 100
#endif

/* (state) stack */
#if (YYSTACK_SIZE) != 0
static yystack_t YYNEAR yystack[(YYSTACK_SIZE)];
yystack_t *YYNEAR YYDCDECL yysstackptr = yystack;
yystack_t *YYNEAR YYDCDECL yystackptr = yystack;
#else
yystack_t *YYNEAR YYDCDECL yysstackptr = NULL;
yystack_t *YYNEAR YYDCDECL yystackptr = NULL;
#endif

/* attribute stack */
#if (YYSTACK_SIZE) != 0
static YYSTYPE YYNEAR yyattributestack[(YYSTACK_SIZE)];
#ifdef YYPROTOTYPE
void *YYNEAR YYDCDECL yysattributestackptr = yyattributestack;
void *YYNEAR YYDCDECL yyattributestackptr = yyattributestack;
#else
char *YYNEAR YYDCDECL yysattributestackptr = (char *) yyattributestack;
char *YYNEAR YYDCDECL yyattributestackptr = (char *) yyattributestack;
#endif
#else
#ifdef YYPROTOTYPE
void *YYNEAR YYDCDECL yysattributestackptr = NULL;
void *YYNEAR YYDCDECL yyattributestackptr = NULL;
#else
char *YYNEAR YYDCDECL yysattributestackptr = NULL;
char *YYNEAR YYDCDECL yyattributestackptr = NULL;
#endif
#endif

int YYNEAR YYDCDECL yysstack_size = (YYSTACK_SIZE);
int YYNEAR YYDCDECL yystack_size = (YYSTACK_SIZE);

/* attributes */
YYSTYPE YYNEAR yyval;
YYSTYPE YYNEAR yylval;
#ifdef YYPROTOTYPE
void *YYNEAR YYDCDECL yyvalptr = &yyval;
void *YYNEAR YYDCDECL yylvalptr = &yylval;
#else
char *YYNEAR YYDCDECL yyvalptr = (char *) &yyval;
char *YYNEAR YYDCDECL yylvalptr = (char *) &yylval;
#endif

size_t YYNEAR YYDCDECL yyattribute_size = sizeof(YYSTYPE);

/* yyattribute */
#ifdef YYDEBUG
#ifdef YYPROTOTYPE
static YYSTYPE *yyattribute1(int index)
#else
static YYSTYPE *yyattribute1(index)
int index;
#endif
{
	YYSTYPE *p = &((YYSTYPE *) yyattributestackptr)[yytop + index];
	return p;
}
#define yyattribute(index) (*yyattribute1(index))
#else
#define yyattribute(index) (((YYSTYPE *) yyattributestackptr)[yytop + (index)])
#endif

#ifdef YYDEBUG
#ifdef YYPROTOTYPE
static void yyinitdebug(YYSTYPE **p, int count)
#else
static void yyinitdebug(p, count)
YYSTYPE **p;
int count;
#endif
{
	int i;
	yyassert(p != NULL);
	yyassert(count >= 1);

	for (i = 0; i < count; i++) {
		p[i] = &((YYSTYPE *) yyattributestackptr)[yytop + i - (count - 1)];
	}
}
#endif

#ifdef YYPROTOTYPE
void YYCDECL yyparseaction(int action)
#else
void YYCDECL yyparseaction(action)
int action;
#endif
{
	switch (action) {
	case 0:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[2];
			yyinitdebug(yya, 2);
#endif
			{
#line 81 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 cuartetos.AddTail(yyattribute(1 - 1).sa.GetList()); 
#line 157 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 1:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[3];
			yyinitdebug(yya, 3);
#endif
			{
#line 82 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 cuartetos.AddTail(yyattribute(2 - 2).sa.GetList()); 
#line 170 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 2:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[5];
			yyinitdebug(yya, 5);
#endif
			{
#line 85 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				AddCuartetoAsign('=', yyattribute(1 - 4).pSymbol, yyattribute(3 - 4).sa, yyval.sa);
				fprintf(yyout, "Sentencia de asignacin valida\n");
			
#line 186 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 3:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[3];
			yyinitdebug(yya, 3);
#endif
			{
#line 89 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				ConcatenarCodigo(yyval.sa, yyattribute(1 - 2).sa);
				fprintf(yyout, "Sentencia valida\n");
			
#line 202 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 4:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[2];
			yyinitdebug(yya, 2);
#endif
			{
#line 93 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				ConcatenarCodigo(yyval.sa, yyattribute(1 - 1).sa);
				fprintf(yyout, "Sentencia if valida\n");
			
#line 218 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 5:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[2];
			yyinitdebug(yya, 2);
#endif
			{
#line 97 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				ConcatenarCodigo(yyval.sa, yyattribute(1 - 1).sa);
				fprintf(yyout, "Sentencia while valida\n");
			
#line 234 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 6:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[4];
			yyinitdebug(yya, 4);
#endif
			{
#line 101 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				ConcatenarCodigo(yyval.sa, yyattribute(2 - 3).sa);
				fprintf(yyout, "Sentencia compuesta valida\n");
			
#line 250 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 7:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[7];
			yyinitdebug(yya, 7);
#endif
			{
#line 105 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				AddCuartetoRead(KW_READ, yyattribute(1 - 6).pSymbol, yyval.sa);
				fprintf(yyout, "Sentencia Read valida\n");
			
#line 266 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 8:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[6];
			yyinitdebug(yya, 6);
#endif
			{
#line 109 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				AddCuartetoWrite(KW_WRITE, yyattribute(3 - 5).sa, yyval.sa);
				fprintf(yyout, "Sentencia Write expresin valida\n");
			
#line 282 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 9:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[6];
			yyinitdebug(yya, 6);
#endif
			{
#line 113 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				AddCuartetoWrite(KW_WRITE, yyattribute(3 - 5).pText, yyval.sa);
				fprintf(yyout, "Sentencia Write string valida\n");
			
#line 298 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 10:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[5];
			yyinitdebug(yya, 5);
#endif
			{
#line 117 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				AddCuartetoNewLine(KW_NEWLINE, yyval.sa);
				fprintf(yyout, "Sentencia NewLine valida\n");
			
#line 314 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 11:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[3];
			yyinitdebug(yya, 3);
#endif
			{
#line 121 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 
				// No genera cdigo
				g_bDeclaracion = false;
				fprintf(yyout, "Delaracin valida\n"); 
			
#line 331 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 12:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[2];
			yyinitdebug(yya, 2);
#endif
			{
#line 128 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 
				ConcatenarCodigo(yyval.sa, yyattribute(1 - 1).sa); 
			
#line 346 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 13:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[3];
			yyinitdebug(yya, 3);
#endif
			{
#line 131 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 
				ConcatenarCodigo(yyval.sa, yyattribute(1 - 2).sa);
				ConcatenarCodigo(yyval.sa, yyattribute(2 - 2).sa);
			
#line 362 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 14:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[6];
			yyinitdebug(yya, 6);
#endif
			{
#line 141 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				AddCuartetoIf(yyattribute(3 - 5).sa, yyattribute(5 - 5).sa, yyval.sa);	
			
#line 377 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 15:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[8];
			yyinitdebug(yya, 8);
#endif
			{
#line 144 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				AddCuartetoIfElse(yyattribute(3 - 7).sa, yyattribute(5 - 7).sa, yyattribute(7 - 7).sa, yyval.sa);
			
#line 392 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 16:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[6];
			yyinitdebug(yya, 6);
#endif
			{
#line 149 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

				AddCuartetoWhile(yyattribute(3 - 5).sa, yyattribute(5 - 5).sa, yyval.sa);
			
#line 407 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 17:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[4];
			yyinitdebug(yya, 4);
#endif
			{
#line 154 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 
				AddCuartetoComp(yyattribute(2 - 3).nCompCode, yyattribute(1 - 3).sa, yyattribute(3 - 3).sa, yyval.sa);
			
#line 422 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 18:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[4];
			yyinitdebug(yya, 4);
#endif
			{
#line 157 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 
				AddCuartetoOR('|',yyattribute(1 - 3).sa,yyattribute(3 - 3).sa,yyval.sa); 
			
#line 437 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 19:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[4];
			yyinitdebug(yya, 4);
#endif
			{
#line 160 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 
				AddCuartetoAND('&',yyattribute(1 - 3).sa,yyattribute(3 - 3).sa,yyval.sa); 
			
#line 452 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 20:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[4];
			yyinitdebug(yya, 4);
#endif
			{
#line 165 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 AddCuartetoOpBinario('+',yyattribute(1 - 3).sa,yyattribute(3 - 3).sa,yyval.sa); 
#line 465 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 21:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[4];
			yyinitdebug(yya, 4);
#endif
			{
#line 166 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 AddCuartetoOpBinario('-',yyattribute(1 - 3).sa,yyattribute(3 - 3).sa,yyval.sa); 
#line 478 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 22:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[4];
			yyinitdebug(yya, 4);
#endif
			{
#line 167 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 AddCuartetoOpBinario('*',yyattribute(1 - 3).sa,yyattribute(3 - 3).sa,yyval.sa); 
#line 491 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 23:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[4];
			yyinitdebug(yya, 4);
#endif
			{
#line 168 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 AddCuartetoOpBinario('/',yyattribute(1 - 3).sa,yyattribute(3 - 3).sa,yyval.sa); 
#line 504 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 24:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[3];
			yyinitdebug(yya, 3);
#endif
			{
#line 170 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 AddCuartetoMenosUnario(yyattribute(2 - 2).sa, yyval.sa); 
#line 517 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 25:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[4];
			yyinitdebug(yya, 4);
#endif
			{
#line 171 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 yyval.sa = yyattribute(2 - 3).sa; 
#line 530 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 26:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[2];
			yyinitdebug(yya, 2);
#endif
			{
#line 173 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 
				yyval.sa.value.pSymbol = yyattribute(1 - 1).pSymbol; 
				yyval.sa.nType = TYPE_SYMBOL;
			
#line 546 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	case 27:
		{
#ifdef YYDEBUG
			YYSTYPE *yya[2];
			yyinitdebug(yya, 2);
#endif
			{
#line 178 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"
 
				yyval.sa.value.nConst = yyattribute(1 - 1).nConst; 
				yyval.sa.nType = TYPE_CONST;
			
#line 562 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"
			}
		}
		break;
	default:
		yyassert(0);
		break;
	}
}
#line 184 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.y"

extern "C" FILE *yyin;

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   PSTR szCmdLine, int iCmdShow)
{
	int ret = 0;
	if (__argc != 4) 
	{
		ErrorMessage("Error en la lnea de comando");
		return 1;
	}
	if( (yyin  = fopen(__argv[1], "rt" )) == NULL ) 
	{
		ErrorMessage("Error al abrir el archivo de entrada");
		return 1;
	}
	if((yyout = fopen(__argv[2], "wt" )) == NULL ) 
	{
		fclose(yyin);
		ErrorMessage("Error al abrir el archivo de salida");
		return 1;
	}
    
    fprintf(yyout, "Inicio del parsing ( versin %.2f )\n\n", g_fNroVersion);
    
	while(!feof(yyin)) {
		yyparse();
	}
	
	// Fin del parsing. Si no hubo errores comenzar la
	// generacin de cdigo.
	if (g_nErrors == 0) {
		fprintf(yyout, "\nIniciando generacin de cdigo...\n");
		ret = 0;
		GenerarCodigo(__argv[3]);
	}
	else {
		fprintf(yyout, "\nGeneracin de cdigo cancelada\n");
		ret = 500;	// Indica que se cancelo la generacin de cdigo
	}
		
	/* Guardar en el archivo de salida el estado actual */
	fprintf(yyout, "\nTabla de smbolos\n\n");
	NODEPOS pos = symTable.GetHeadPos();
	
	while (pos)
		symTable.GetNext(pos).Write(yyout);
		
	fprintf(yyout, "\nCuartetos\n\n");	
	
	pos = cuartetos.GetHeadPos();
	
	while (pos)
		cuartetos.GetNext(pos).Write(yyout, symTable, labels, stringList);
		
	// La lista de strings es de punteros y hay que eliminar su contenido.
	pos = stringList.GetHeadPos();
	
	while (pos)
		delete[] stringList.GetNext(pos);
		
	fprintf(yyout, "\n-------------------------------------------------------------\n");
	fprintf(yyout, "%s -- errores %d, advertencias 0\n", __argv[1], g_nErrors);

	 _fcloseall( );

	return ret;
}

void yyerror(const char* s)
{
	int c;
	
	g_nErrors++;
	
	if (feof(yyin))
		fprintf(yyout, "ERROR: inesperado fin de archivo\n");
	else
		fprintf(yyout, "ERROR: sintxis desconocida en lnea: %d\n", g_nLine);
	
	do {
		c = getc(yyin);
		if (c == '\n') g_nLine++;
	} while (c != ';' && c != EOF);
}

void ErrorMessage(char* szMsg)
{
	MessageBox(NULL, szMsg, "Error", MB_OK | MB_ICONERROR);
}

///////////////////////////////////////////////////////////////////////
// Funciones auxiliares para la generacin de cuartetos

PSYMBOL GetVarTemp()
{
	static i = 0;
	
	if (freeVarTemps.IsEmpty()) {
		SYMBOL sym;
		
		strcpy(sym.name, "_Tmp");
		_itoa(i++, sym.name + 4, 10);
		
		symTable.AddTail(sym);
		
		return symTable.GetTailPos();
	}
	else
		return freeVarTemps.Pop();
}

PLABEL GetLabel()
{
	static i = 0;
	
	LABEL label;
	
	strcpy(label.name, "LABEL");
	_itoa(i++, label.name + 5, 10);
	labels.AddTail(label);
	
	return labels.GetTailPos();
}

void FreeVarTemp(PSYMBOL pSymbol)
{
	freeVarTemps.Push(pSymbol);
}

void InvertComp(int& comp)
{
	switch (comp) {
		case '>': comp = MENIG; break;
		case '<': comp = MAYIG; break;
		case MENIG: comp = '>'; break;
		case MAYIG: comp = '<'; break;
		case IGIG: comp = DIST; break;
		case DIST: comp = IGIG; break;
	}
}

///////////////////////////////////////////////////////////////////////
// Funciones generadoras de cuartetos

void AddCuartetoOpBinario(int label, SA& arg1, SA& arg2, SA& res)
{	
	CUARTETO c;
	
	ConcatenarCodigo(res, arg1);
	ConcatenarCodigo(res, arg2);
	
	// Si arg1 o arg2 son variables temporales, las liberamos
	// para que puedan se reutilizadas.
	if (arg1.nType & TYPE_TEMP)
		FreeVarTemp(arg1.value.pSymbol);		
	if (arg2.nType & TYPE_TEMP)
		FreeVarTemp(arg2.value.pSymbol);

	// Obtenemos una variable temporal para almacenar el resultado
	res.value.pSymbol = GetVarTemp();
	res.nType = TYPE_SYMBOL | TYPE_TEMP;

	// Aadimos el cuarteto de la operacin
	c.label = label;
	c.arg1 = arg1.value;
	c.arg2 = arg2.value;
	c.res = res.value;
	c.disc = SYMR;
	c.disc |= (arg1.nType & TYPE_SYMBOL) ? SYM1:CONS1;
	c.disc |= (arg2.nType & TYPE_SYMBOL) ? SYM2:CONS2;	
	res.GetList().AddTail(c);
}

void AddCuartetoAsign(int label, PSYMBOL arg1, SA& arg2, SA& res)
{
	CUARTETO c;
	
	ConcatenarCodigo(res, arg2);
	
	// Si arg2 es una variable temporal, la liberamos.
	if (arg2.nType & TYPE_TEMP)
		FreeVarTemp(arg2.value.pSymbol);
	
	// El resultado debe quedar en arg1	                                  
	res.value.pSymbol = arg1;
	res.nType = TYPE_SYMBOL;

	// Advertencia: arg2 debe ser el arg1 del cuarteto
	// y el arg2 del cuarteto no se utiliza.
	c.label = label;
	c.arg1 = arg2.value;
	c.res = res.value;
	c.disc = SYMR;
	c.disc |= (arg2.nType & TYPE_SYMBOL) ? SYM1:CONS1;
	c.disc |= UN2;	// arg2 no utilizado
	res.GetList().AddTail(c);
}

void AddCuartetoMenosUnario(SA& arg1, SA& res)
{
	if (arg1.nType & TYPE_SYMBOL) {
		SA arg2;
		arg2.value.nConst = -1; 
		arg2.nType = TYPE_CONST;
		arg2.m_pLast = NULL;
		arg2.m_nCount = 0;
		AddCuartetoOpBinario('*', arg1, arg2, res);
	}
	else if (arg1.nType & TYPE_CONST) {
		res.value.nConst = arg1.value.nConst * -1; 
		res.nType = TYPE_CONST;
	}
	else
		ErrorMessage("DEBUG");
}

void AddCuartetoWhile(SA& condicion, SA& sentencia, SA& res)
{
	CUARTETO c;
	PLABEL labelBegin, labelCode, labelEnd; 
	bool bAddLabelCode = false;
	
	labelBegin = GetLabel();
	labelEnd = GetLabel();
	
	// Agregar etiqueta origen
	c.label = KW_LABEL;
	c.arg1.pLabel = labelBegin;
	c.disc = LBL1 | UN2 | UNR;	// Label en 1 y agr2 y res no usados
	res.GetList().AddTail(c);
	
	NODEPOS pos = condicion.GetList().GetHeadPos();
	
	while (pos) {
		CUARTETO& cc = condicion.GetList().GetNext(pos);
		
		if (cc.disc & JMPR) {
			switch (cc.res.nConst) {
				case JUMPTO1:
					if (!bAddLabelCode) {
						bAddLabelCode = true;
						labelCode = GetLabel();
					}
					cc.res.pLabel = labelCode; 
					break;
			 	case JUMPTO2:
			 		cc.res.pLabel = labelEnd; 
			 		break;
			 	case UNKNOWNJUMP:
			 		InvertComp(cc.label);
			 		cc.res.pLabel = labelEnd; 
			 		break;
			 	default:
			 		ErrorMessage("DEBUG");
			 }
			 cc.disc &= ~JMPR;
			 cc.disc |= LBLR;
		}
	}
	
	// Agregar el cdigo de la condicin
	ConcatenarCodigo(res, condicion);
	                         
	if (bAddLabelCode) {
		// Agregar etiqueta comienzo
		c.label = KW_LABEL;
		c.arg1.pLabel = labelCode;
		c.disc = LBL1 | UN2 | UNR;
		res.GetList().AddTail(c);
	}
	
	// Agregar el cdigo de la/s sentencia/s	                         
	ConcatenarCodigo(res, sentencia);
	
	// Agregar salto incondicional al comienzo
	c.label = KW_GOTO;
	c.arg1.pLabel = labelBegin;
	c.disc = LBL1 | UN2 | UNR;
	res.GetList().AddTail(c);
	
	// Agregar etiqueta final
	c.label = KW_LABEL;
	c.arg1.pLabel = labelEnd;
	c.disc = LBL1 | UN2 | UNR;
	res.GetList().AddTail(c);
}      

void AddCuartetoIf(SA& condicion, SA& sentencia, SA& res)
{
	CUARTETO c;
	PLABEL labelBegin, labelEnd;
	bool bAddLabelBegin = false;

	labelEnd = GetLabel();
	
	NODEPOS pos = condicion.GetList().GetHeadPos();
	
	while (pos) {
		CUARTETO& cc = condicion.GetList().GetNext(pos);
		
		if (cc.disc & JMPR) {
			switch (cc.res.nConst) {
				case JUMPTO1:
					if (!bAddLabelBegin) {
						bAddLabelBegin = true;
						labelBegin = GetLabel();
					}
					cc.res.pLabel = labelBegin; 
					break;
			 	case JUMPTO2:
			 		cc.res.pLabel = labelEnd; 
			 		break;
			 	case UNKNOWNJUMP:
			 		InvertComp(cc.label);
			 		cc.res.pLabel = labelEnd; 
			 		break;
			 	default:
			 		ErrorMessage("DEBUG");
			 }
			 cc.disc &= ~JMPR;
			 cc.disc |= LBLR;
		}
	}
	
	// Agregar el cdigo de la condicin
	ConcatenarCodigo(res, condicion); 
	
	if (bAddLabelBegin) {
		// Agregar etiqueta comienzo
		c.label = KW_LABEL;
		c.arg1.pLabel = labelBegin;
		c.disc = LBL1 | UN2 | UNR;
		res.GetList().AddTail(c);
	}
	
	// Agregar el cdigo de la/s sentencia/s	                         
	ConcatenarCodigo(res, sentencia);
	
	// Agregar etiqueta final
	c.label = KW_LABEL;
	c.arg1.pLabel = labelEnd;
	c.disc = LBL1 | UN2 | UNR;
	res.GetList().AddTail(c);
}

void AddCuartetoIfElse(SA& condicion, SA& sentencia, SA& sentElse, SA& res)
{
	CUARTETO c;
	PLABEL labelBegin, labelElse, labelEnd;
	bool bAddLabelBegin = false;

	labelElse = GetLabel();
	labelEnd = GetLabel();
	
	NODEPOS pos = condicion.GetList().GetHeadPos();
	
	while (pos) {
		CUARTETO& cc = condicion.GetList().GetNext(pos);
		
		if (cc.disc & JMPR) {
			switch (cc.res.nConst) {
				case JUMPTO1:
					if (!bAddLabelBegin) {
						bAddLabelBegin = true;
						labelBegin = GetLabel();
					}
					cc.res.pLabel = labelBegin; 
					break;
			 	case JUMPTO2:
			 		cc.res.pLabel = labelElse; 
			 		break;
			 	case UNKNOWNJUMP:
			 		InvertComp(cc.label);
			 		cc.res.pLabel = labelElse; 
			 		break;
			 	default:
			 		ErrorMessage("DEBUG");
			 }
			 cc.disc &= ~JMPR;
			 cc.disc |= LBLR;
		}
	}
	
	// Agregar el cdigo de la condicin
	ConcatenarCodigo(res, condicion); 
	
	if (bAddLabelBegin) {
		// Agregar etiqueta comienzo
		c.label = KW_LABEL;
		c.arg1.pLabel = labelBegin;
		c.disc = LBL1 | UN2 | UNR;
		res.GetList().AddTail(c);
	}
	
	// Agregar el cdigo de la/s sentencia/s	                         
	ConcatenarCodigo(res, sentencia);
	
	// Agregar salto incondicional al final
	c.label = KW_GOTO;
	c.arg1.pLabel = labelEnd;
	c.disc = LBL1 | UN2 | UNR;
	res.GetList().AddTail(c);
	
	// Agregar etiqueta del else
	c.label = KW_LABEL;
	c.arg1.pLabel = labelElse;
	c.disc = LBL1 | UN2 | UNR;
	res.GetList().AddTail(c);
	
	// Agregar el cdigo de la/s sentencia/s del else
	ConcatenarCodigo(res, sentElse);
	
	// Agregar etiqueta final
	c.label = KW_LABEL;
	c.arg1.pLabel = labelEnd;
	c.disc = LBL1 | UN2 | UNR;
	res.GetList().AddTail(c);
}

void AddCuartetoRead(int label, PSYMBOL arg1, SA& res)
{
	CUARTETO c;

	c.label = label;
	c.res.pSymbol = arg1;
	c.disc = UN1 | UN2 | SYMR;
	res.GetList().AddTail(c);
}

void AddCuartetoWrite(int label, PSTRING arg1, SA& res)
{
	CUARTETO c;
	
	c.label = label;
	c.arg1.pText = arg1;
	c.disc = STR1 | UN2 | UNR;
	
	res.GetList().AddTail(c);
} 

void AddCuartetoNewLine(int label, SA& res)
{
	CUARTETO c;
	
	c.label = label;
	c.disc = UN1 | UN2 | UNR;
	
	res.GetList().AddTail(c);
}

void AddCuartetoWrite(int label, SA& arg1, SA& res)
{
	CUARTETO c;
	
	// Agregar el cdigo de la expresin en arg1
	ConcatenarCodigo(res, arg1);
	
	// Aadir el cuarteto de la operacin
	c.label = label;
	c.arg1 = arg1.value;
	c.disc = (arg1.nType & TYPE_SYMBOL) ? SYM1:CONS1;
	c.disc |= UN2 | UNR;	
	res.GetList().AddTail(c);
	
	// Si la arg1 es una variable temporal, la liberamos.
	if (arg1.nType & TYPE_TEMP)
		FreeVarTemp(arg1.value.pSymbol);
}

void AddCuartetoComp(int label, SA& arg1, SA& arg2, SA& res)
{
	CUARTETO c;
	
	ConcatenarCodigo(res, arg1);
	ConcatenarCodigo(res, arg2);
	
	// Si arg1 o arg2 son variables temporales, las liberamos
	// para que puedan se reutilizadas.
	if (arg1.nType & TYPE_TEMP)
		FreeVarTemp(arg1.value.pSymbol);		
	if (arg2.nType & TYPE_TEMP)
		FreeVarTemp(arg2.value.pSymbol);

	// Aadimos el cuarteto de la operacin
	c.label = label;
	c.arg1 = arg1.value;
	c.arg2 = arg2.value;
	c.res.nConst = UNKNOWNJUMP;	// Todavia no se donde hay que saltar
	
	c.disc = JMPR;	// El resultado no contiene nada relevante
	c.disc |= (arg1.nType & TYPE_SYMBOL) ? SYM1:CONS1;
	c.disc |= (arg2.nType & TYPE_SYMBOL) ? SYM2:CONS2;
	
	res.GetList().AddTail(c);
}

void AddCuartetoOR(int label, SA& arg1, SA& arg2, SA& res)
{
	CSList<CUARTETO>& listArg1 = arg1.GetList();
	
	if (listArg1.GetAt(listArg1.GetTailPos()).res.nConst != UNKNOWNJUMP) 
	{
		PLABEL labelJump;
		
		labelJump = GetLabel();
		
		NODEPOS pos = listArg1.GetHeadPos();
		
		while (pos) {
			CUARTETO& c = listArg1.GetNext(pos);
			
			if ((c.disc & JMPR) && c.res.nConst == JUMPTO2) {
				if (pos) {	// => no es el ltimo
					c.res.pLabel = labelJump;
					c.disc &= ~JMPR;	// Ahora si conoce el salto
					c.disc |= LBLR;
				}
				else {		// Es el ltimo
					InvertComp(c.label);
					c.res.nConst = JUMPTO1;
				}	
			}
		}
		
		ConcatenarCodigo(res, arg1);
		
		CUARTETO c;
		// Agregar etiqueta del jump
		c.label = KW_LABEL;
		c.arg1.pLabel = labelJump;
		c.disc = LBL1 | UN2 | UNR;
		res.GetList().AddTail(c);
	}
	else {
		// El ltimo seguro es un COMP
		CUARTETO& c = listArg1.GetAt(listArg1.GetTailPos());
		
		c.res.nConst = JUMPTO1;
		
		ConcatenarCodigo(res, arg1);
	}
	
	NODEPOS pos = arg2.GetList().GetTailPos();	// El ltimo seguro es un COMP
	CUARTETO& c = arg2.GetList().GetAt(pos);
	
	InvertComp(c.label);
	
	c.res.nConst = JUMPTO2;
	
	ConcatenarCodigo(res, arg2);
}

void AddCuartetoAND(int label, SA& arg1, SA& arg2, SA& res)
{
	CSList<CUARTETO>& listArg1 = arg1.GetList();
	
	if (listArg1.GetAt(listArg1.GetTailPos()).res.nConst != UNKNOWNJUMP) 
	{
		PLABEL labelJump;
		
		labelJump = GetLabel();
		
		NODEPOS pos = listArg1.GetHeadPos();
		
		while (pos) {
			CUARTETO& c = listArg1.GetNext(pos);
			
			if ((c.disc & JMPR) && c.res.nConst == JUMPTO1) {
				c.res.pLabel = labelJump;
				c.disc &= ~JMPR;	// Ahora si conoce el salto
				c.disc |= LBLR;
			}
		}  
		
		ConcatenarCodigo(res, arg1);
		
		CUARTETO c;
		// Agregar etiqueta del jump
		c.label = KW_LABEL;
		c.arg1.pLabel = labelJump;
		c.disc = LBL1 | UN2 | UNR;
		res.GetList().AddTail(c);
	}
	else {
		// El ltimo seguro es un COMP
		CUARTETO& c = arg1.GetList().GetAt(listArg1.GetTailPos());
		
		InvertComp(c.label);
		c.res.nConst = JUMPTO2;
		
		ConcatenarCodigo(res, arg1);
	}
	
	NODEPOS pos = arg2.GetList().GetTailPos();	// El ltimo seguro es un COMP
	CUARTETO& c = arg2.GetList().GetAt(pos);
	
	InvertComp(c.label);
	
	c.res.nConst = JUMPTO2;
	
	ConcatenarCodigo(res, arg2);
}



	

#line 1181 "E:\\Datos\\Programaci\363n\\Proyectos\\Compilador\\Parser\\gramatica.cpp"

#ifdef YYDEBUG
YYCONST yysymbol_t YYNEARFAR YYDCDECL yysymbol[] = {
	{ "$end", 0 },
	{ "\'&\'", 38 },
	{ "\'(\'", 40 },
	{ "\')\'", 41 },
	{ "\'*\'", 42 },
	{ "\'+\'", 43 },
	{ "\',\'", 44 },
	{ "\'-\'", 45 },
	{ "\'/\'", 47 },
	{ "\';\'", 59 },
	{ "\'=\'", 61 },
	{ "\'{\'", 123 },
	{ "\'|\'", 124 },
	{ "\'}\'", 125 },
	{ "error", 256 },
	{ "KW_IF", 257 },
	{ "KW_ELSE", 258 },
	{ "KW_WHILE", 259 },
	{ "KW_INT", 260 },
	{ "KW_READ", 261 },
	{ "KW_WRITE", 262 },
	{ "KW_NEWLINE", 269 },
	{ "ID", 270 },
	{ "CONS", 271 },
	{ "COMP", 272 },
	{ "STRING", 273 },
	{ "MENOS_UNARIO", 274 },
	{ "LOWER_THAN_ELSE", 275 },
	{ NULL, 0 }
};

YYCONST char *YYCONST YYNEARFAR YYDCDECL yyrule[] = {
	"$accept: programa",
	"programa: sentencia",
	"programa: programa sentencia",
	"sentencia: ID \'=\' expresion \';\'",
	"sentencia: expresion \';\'",
	"sentencia: s_if",
	"sentencia: s_while",
	"sentencia: \'{\' lista_sentencias \'}\'",
	"sentencia: ID \'=\' KW_READ \'(\' \')\' \';\'",
	"sentencia: KW_WRITE \'(\' expresion \')\' \';\'",
	"sentencia: KW_WRITE \'(\' STRING \')\' \';\'",
	"sentencia: KW_NEWLINE \'(\' \')\' \';\'",
	"sentencia: declaracion \';\'",
	"lista_sentencias: sentencia",
	"lista_sentencias: lista_sentencias sentencia",
	"declaracion: KW_INT ID",
	"declaracion: declaracion \',\' ID",
	"s_if: KW_IF \'(\' condicion \')\' sentencia",
	"s_if: KW_IF \'(\' condicion \')\' sentencia KW_ELSE sentencia",
	"s_while: KW_WHILE \'(\' condicion \')\' sentencia",
	"condicion: expresion COMP expresion",
	"condicion: condicion \'|\' condicion",
	"condicion: condicion \'&\' condicion",
	"expresion: expresion \'+\' expresion",
	"expresion: expresion \'-\' expresion",
	"expresion: expresion \'*\' expresion",
	"expresion: expresion \'/\' expresion",
	"expresion: \'-\' expresion",
	"expresion: \'(\' expresion \')\'",
	"expresion: ID",
	"expresion: CONS"
};
#endif

YYCONST yyreduction_t YYNEARFAR YYBASED_CODE YYDCDECL yyreduction[] = {
	{ 0, 1, -1 },
	{ 1, 1, 0 },
	{ 1, 2, 1 },
	{ 2, 4, 2 },
	{ 2, 2, 3 },
	{ 2, 1, 4 },
	{ 2, 1, 5 },
	{ 2, 3, 6 },
	{ 2, 6, 7 },
	{ 2, 5, 8 },
	{ 2, 5, 9 },
	{ 2, 4, 10 },
	{ 2, 2, 11 },
	{ 3, 1, 12 },
	{ 3, 2, 13 },
	{ 4, 2, -1 },
	{ 4, 3, -1 },
	{ 5, 5, 14 },
	{ 5, 7, 15 },
	{ 6, 5, 16 },
	{ 7, 3, 17 },
	{ 7, 3, 18 },
	{ 7, 3, 19 },
	{ 8, 3, 20 },
	{ 8, 3, 21 },
	{ 8, 3, 22 },
	{ 8, 3, 23 },
	{ 8, 2, 24 },
	{ 8, 3, 25 },
	{ 8, 1, 26 },
	{ 8, 1, 27 }
};

YYCONST yytokenaction_t YYNEARFAR YYBASED_CODE YYDCDECL yytokenaction[] = {
	{ 1, YYAT_SHIFT, 1 },
	{ 39, YYAT_ERROR, 0 },
	{ 0, YYAT_SHIFT, 3 },
	{ 41, YYAT_SHIFT, 53 },
	{ 43, YYAT_SHIFT, 58 },
	{ 1, YYAT_SHIFT, 2 },
	{ 41, YYAT_SHIFT, 56 },
	{ 46, YYAT_SHIFT, 29 },
	{ 46, YYAT_SHIFT, 30 },
	{ 69, YYAT_SHIFT, 71 },
	{ 46, YYAT_SHIFT, 31 },
	{ 16, YYAT_SHIFT, 34 },
	{ 46, YYAT_SHIFT, 32 },
	{ 62, YYAT_SHIFT, 29 },
	{ 62, YYAT_SHIFT, 30 },
	{ 49, YYAT_SHIFT, 29 },
	{ 62, YYAT_SHIFT, 31 },
	{ 64, YYAT_SHIFT, 70 },
	{ 62, YYAT_SHIFT, 32 },
	{ 60, YYAT_SHIFT, 69 },
	{ 49, YYAT_SHIFT, 32 },
	{ 58, YYAT_SHIFT, 68 },
	{ 43, YYAT_ERROR, 0 },
	{ 48, YYAT_SHIFT, 29 },
	{ 46, YYAT_SHIFT, 61 },
	{ 57, YYAT_SHIFT, 67 },
	{ 16, YYAT_SHIFT, 35 },
	{ 45, YYAT_SHIFT, 60 },
	{ 48, YYAT_SHIFT, 32 },
	{ 44, YYAT_SHIFT, 59 },
	{ 42, YYAT_SHIFT, 57 },
	{ 40, YYAT_SHIFT, 54 },
	{ 34, YYAT_SHIFT, 51 },
	{ 27, YYAT_SHIFT, 45 },
	{ 26, YYAT_SHIFT, 44 },
	{ 25, YYAT_SHIFT, 42 },
	{ 21, YYAT_SHIFT, 37 },
	{ 18, YYAT_SHIFT, 36 },
	{ 15, YYAT_SHIFT, 33 },
	{ 11, YYAT_ACCEPT, 0 },
	{ 9, YYAT_SHIFT, 27 },
	{ 8, YYAT_SHIFT, 26 },
	{ 7, YYAT_SHIFT, 25 },
	{ 6, YYAT_SHIFT, 24 },
	{ 5, YYAT_SHIFT, 23 },
	{ 4, YYAT_SHIFT, 22 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ 41, YYAT_SHIFT, 55 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ 0, YYAT_SHIFT, 4 },
	{ -1, YYAT_ERROR, 0 },
	{ 0, YYAT_SHIFT, 5 },
	{ 0, YYAT_SHIFT, 6 },
	{ -1, YYAT_ERROR, 0 },
	{ 0, YYAT_SHIFT, 7 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ 0, YYAT_SHIFT, 8 },
	{ 0, YYAT_SHIFT, 9 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ -1, YYAT_ERROR, 0 },
	{ 1, YYAT_SHIFT, 17 },
	{ 1, YYAT_SHIFT, 10 },
	{ 39, YYAT_SHIFT, 52 }
};
int YYNEAR YYDCDECL yytokenaction_size = 233;

YYCONST yystateaction_t YYNEARFAR YYBASED_CODE YYDCDECL yystateaction[] = {
	{ -121, 1, YYAT_DEFAULT, 1 },
	{ -40, 1, YYAT_ERROR, 0 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_DEFAULT, 0 },
	{ 5, 1, YYAT_ERROR, 0 },
	{ 4, 1, YYAT_ERROR, 0 },
	{ -227, 1, YYAT_ERROR, 0 },
	{ 2, 1, YYAT_ERROR, 0 },
	{ 1, 1, YYAT_ERROR, 0 },
	{ -21, 1, YYAT_REDUCE, 29 },
	{ 0, 0, YYAT_REDUCE, 30 },
	{ 39, 1, YYAT_DEFAULT, 0 },
	{ 0, 0, YYAT_REDUCE, 1 },
	{ 0, 0, YYAT_REDUCE, 5 },
	{ 0, 0, YYAT_REDUCE, 6 },
	{ -21, 1, YYAT_DEFAULT, 46 },
	{ -33, 1, YYAT_ERROR, 0 },
	{ 0, 0, YYAT_REDUCE, 29 },
	{ -4, 1, YYAT_DEFAULT, 43 },
	{ 0, 0, YYAT_REDUCE, 27 },
	{ 0, 0, YYAT_REDUCE, 13 },
	{ -89, 1, YYAT_DEFAULT, 0 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_REDUCE, 15 },
	{ -238, 1, YYAT_DEFAULT, 1 },
	{ -7, 1, YYAT_ERROR, 0 },
	{ -228, 1, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_REDUCE, 2 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_REDUCE, 4 },
	{ -238, 1, YYAT_ERROR, 0 },
	{ 0, 0, YYAT_REDUCE, 12 },
	{ 0, 0, YYAT_REDUCE, 28 },
	{ 0, 0, YYAT_REDUCE, 7 },
	{ 0, 0, YYAT_REDUCE, 14 },
	{ -40, 1, YYAT_DEFAULT, 43 },
	{ -10, 1, YYAT_DEFAULT, 41 },
	{ -35, 1, YYAT_ERROR, 0 },
	{ -11, 1, YYAT_ERROR, 0 },
	{ -37, 1, YYAT_DEFAULT, 46 },
	{ -30, 1, YYAT_ERROR, 0 },
	{ -13, 1, YYAT_ERROR, 0 },
	{ -35, 1, YYAT_ERROR, 0 },
	{ 0, 0, YYAT_REDUCE, 25 },
	{ -19, 1, YYAT_REDUCE, 23 },
	{ -27, 1, YYAT_REDUCE, 24 },
	{ 0, 0, YYAT_REDUCE, 26 },
	{ 0, 0, YYAT_REDUCE, 16 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_DEFAULT, 0 },
	{ 0, 0, YYAT_DEFAULT, 1 },
	{ 0, 0, YYAT_DEFAULT, 0 },
	{ -34, 1, YYAT_ERROR, 0 },
	{ -38, 1, YYAT_ERROR, 0 },
	{ 0, 0, YYAT_REDUCE, 11 },
	{ -22, 1, YYAT_ERROR, 0 },
	{ 0, 0, YYAT_REDUCE, 3 },
	{ -29, 1, YYAT_REDUCE, 20 },
	{ 0, 0, YYAT_REDUCE, 22 },
	{ -241, 1, YYAT_REDUCE, 17 },
	{ 0, 0, YYAT_REDUCE, 21 },
	{ 0, 0, YYAT_REDUCE, 19 },
	{ 0, 0, YYAT_REDUCE, 10 },
	{ 0, 0, YYAT_REDUCE, 9 },
	{ -50, 1, YYAT_ERROR, 0 },
	{ 0, 0, YYAT_DEFAULT, 0 },
	{ 0, 0, YYAT_REDUCE, 8 },
	{ 0, 0, YYAT_REDUCE, 18 }
};

YYCONST yystategoto_t YYNEARFAR YYBASED_CODE YYDCDECL yystategoto[] = {
	{ 8, 18 },
	{ 8, 19 },
	{ 2, 20 },
	{ 7, 41 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ 2, 28 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ 2, 38 },
	{ 8, 39 },
	{ 8, 39 },
	{ -1, -1 },
	{ 8, 43 },
	{ -1, -1 },
	{ 8, 46 },
	{ -1, -1 },
	{ 8, 47 },
	{ 8, 48 },
	{ 8, 49 },
	{ 8, 50 },
	{ -1, -1 },
	{ 7, 63 },
	{ -1, -1 },
	{ 7, 65 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ 8, 62 },
	{ 8, 39 },
	{ 2, 64 },
	{ 8, 39 },
	{ 2, 66 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ -1, -1 },
	{ 2, 72 }
};
int YYNEAR YYDCDECL yystategoto_size = 70;

YYCONST yynontermgoto_t YYNEARFAR YYBASED_CODE YYDCDECL yynontermgoto[] = {
	{ 0, -1 },
	{ 0, 11 },
	{ -1, 12 },
	{ 0, 21 },
	{ 0, 16 },
	{ 0, 13 },
	{ 0, 14 },
	{ -20, 40 },
	{ -1, 15 }
};

YYCONST yydestructor_t YYNEARFAR *YYNEAR YYDCDECL yydestructorptr = NULL;
