/*------------------------------------------------
 PASADA1.CPP
--------------------------------------------------*/
#include <windows.h>
//#include <afxwin.h>
//#include <afxtempl.h>
#include <stdio.h>
#include "Constantes.h"
#include "matriz.h"

/* Prototipos */
int GetToken();
int GetEvent(int c);
void ErrorMessage(char* szMsg);
void PrintOutput(int token);

/* Variables globales */
FILE *in, *out;
//CList<ROW, ROW&> symbolTable;
char lexBuffer[MAXLEXBUFFER], lexBufferLength = 0;
int nLineCount = 0, nOldLineCount = 0, nLineTokenCount = 0;


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   PSTR szCmdLine, int iCmdShow)
{
	if (__argc != 3) 
	{
		ErrorMessage("Error en la lnea de comando");
		return 1;
	}
	if( (in  = fopen(__argv[1], "rt" )) == NULL ) 
	{
		ErrorMessage("Error al abrir el archivo de entrada");
		return 1;
	}
	if((out = fopen(__argv[2], "wt" )) == NULL ) 
	{
		fclose(in);
		ErrorMessage("Error al abrir el archivo de salida");
		return 1;
	}

	int token;

	while ((token = GetToken()) != EOF)
		PrintOutput(token);

	 _fcloseall( );

	return 0;
}

int GetEvent(int c)
{
	if (isalpha(c)) return 0;
	if (isdigit(c)) return 1;
	if (c == '/') return 2;
	if (c == '*') return 3;
	if (c == '<' || c == '>' || c == '=') return 4;
	if (c == '\t' || c == ' ') return 5;
	if (c == '\n') {
		if (nLineTokenCount)
		{
			nLineCount++;
			nLineTokenCount = 0;
		}
		return 6;
	}
	if (c == '"') return 7;
	if (c == '\\') return 8;

	return EOF;
}

int GetToken()
{
	int c, event, state = 0, token;
	lexBufferLength = 0;

	do {
		c = fgetc(in);
		event = GetEvent(c);
		
		if (event == EOF) return EOF;

		token = (*pfSemRut[state][event])((char)c);
		state = newState[state][event];

	} while (state != END);

	nLineTokenCount++;

	return token;
}

void ErrorMessage(char* szMsg)
{
	MessageBox(NULL, szMsg, "Error", MB_OK | MB_ICONERROR);
}

int OnVar(char c)
{
 	lexBuffer[lexBufferLength++] = c;

	return VARIABLE;
}

int OnCons(char c)
{
	lexBuffer[lexBufferLength++] = c;

	return CONSTANT;
}

int OnComp(char c)
{
	int nc = fgetc(in);
	if (nc != '=') ungetc(nc, in);

	return COMP;
}

int OnNull(char c)
{
	return NULL;
}

int OnRWrd(char c)
{
	lexBuffer[lexBufferLength] = '\0';
	int token;

	if (nLineTokenCount == 0) {
		int nc = fgetc(in);
		if (nc == ':') return LABEL;
		else ungetc(nc, in);
	}

	if (!strcmp(lexBuffer, "if")) token = IF;
	else if (!strcmp(lexBuffer, "then")) token = THEN;
	else if (!strcmp(lexBuffer, "else")) token = ELSE;
	else if (!strcmp(lexBuffer, "endif")) token = ENDIF;
	else if (!strcmp(lexBuffer, "return")) token = RETURN;
	else token = VARIABLE;

	return token;
}

int OnEndC(char c)
{
	return CONSTANT;
}

int OnStr(char c)
{
	static int comillas = 0;

	if (c == '\\') {
		int nc = fgetc(in);
		if (nc == '"') 
			lexBuffer[lexBufferLength++] = nc;
		else {
			ungetc(nc, in);
			lexBuffer[lexBufferLength++] = c;
		}
	}

	return STRING;
}

int OnEndS(char c)
{
	return STRING;
}

void PrintOutput(int token)
{
	switch (token) 
	{
		case NULL: 
			fprintf(out, "null(%d), ", token); 
			break;
		case VARIABLE: 
			fprintf(out, "variable(%d), ", token); 
			break;
		case CONSTANT: 
			fprintf(out, "constante(%d), ", token); 
			break;
		case DIV: 
			fprintf(out, "div(%d), ", token); 
			break;
		case COMP: 
			fprintf(out, "comp(%d), ", token); 
			break;
		case IF: 
			fprintf(out, "if(%d), ", token); 
			break;
		case THEN: 
			fprintf(out, "then(%d), ", token); 
			break;
		case ELSE: 
			fprintf(out, "else(%d), ", token); 
			break;
		case ENDIF: 
			fprintf(out, "endif(%d), ", token); 
			break;
		case RETURN: 
			fprintf(out, "return(%d), ", token); 
			break;
		case STRING: 
			fprintf(out, "string(%d), ", token); 
			break;
		case LABEL: 
			fprintf(out, "label(%d), ", token); 
			break;
		default: 
			fprintf(out, "algo raro(%d), ", token); 
			break;
	}
	if (nLineCount != nOldLineCount) {
		nOldLineCount = nLineCount;
		fputc('\n', out);
	}
}